public class BadInterleavingExample {
    // Shared variable
    private static int counter = 0;

    public static void main(String[] args) throws InterruptedException {
        // Define a task that increments the counter multiple times

        Runnable incrementTask = new Runnable() {
            @Override
            public void run(){
                for (int i = 0; i < 10000; i++){
                    counter++;
                }
            }
        };

        // Create two threads running the same task
        Thread t1 = new Thread(incrementTask);
        Thread t2 = new Thread(incrementTask);

        // Start both threads
        t1.start();
        t2.start();

        // Wait for both threads to finish
        t1.join();
        t2.join();

        // Ideally, we expect 20000, but we often get a lower number
        System.out.println("Final counter value: " + counter);
    }
}
