package session02;

public class ThreadExample {

	public static void main(String[] args) {
		// print from a different thread
		// ensure main thread finishes only after other thread has finished

		// uncomment as needed
		inline();
//		separateClassInheritance();
//		separateClassInterface();
	}

	public static void inline() {
		System.out.println("main thread start " + Thread.currentThread().getName()); // or getId()

		Thread thread = new Thread(new Runnable() {
			@Override
			public void run() {
				System.out.println("other thread runs " + Thread.currentThread().getName());
			}
		});

		thread.start();

		try {
			thread.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		System.out.println("main thread end " + Thread.currentThread().getName());
	}

	public static void separateClassInheritance() {
		System.out.println("main thread start " + Thread.currentThread().getName());

		MyThread thread = new MyThread();

		thread.start();

		try {
			thread.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		System.out.println("main thread end " + Thread.currentThread().getName());
	}

	public static void separateClassInterface() {
		System.out.println("main thread start " + Thread.currentThread().getName());

		MyRunnable runnable = new MyRunnable();
		Thread thread = new Thread(runnable);

		thread.start();

		try {
			thread.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		System.out.println("main thread end " + Thread.currentThread().getName());
	}
}

class MyThread extends Thread {
	@Override
	public void run() {
		System.out.println("other thread runs " + Thread.currentThread().getName());
	}
}

class MyRunnable implements Runnable {
	@Override
	public void run() {
		System.out.println("other thread runs " + Thread.currentThread().getName());
	}
}